/**
 * A user script for userChrome.js extension.
 * @name PeCaListHelper
 * @description リンクを専用プレイヤー/ブラウザで開く
 * @compatibility Firefox 2.0～3.0
 * @author PeerSkin
 * @lastupdated 2007.10.14
 * @permalink http://peercast-theme.seesaa.net/
 * ------------------------------------------------------------------
 * ストリームURL（チャンネルの再生リンク）を中クリックしたときに
 * 指定したメディアプレイヤーで再生します。また、指定したURLを
 * 中クリックしたときに2chブラウザなど指定したソフトで開きます。
 * ------------------------------------------------------------------
 * オリジナル：launch2chBrowser.uc.js
 * http://firefox.geckodev.org/?cmd=attach&pcmd=upload&page=userChrome.js
 */

function ucjs_rewrite_handleLinkClick(event, href, linkNode) {
	
	// ■■ 設定ここから ■■
	// パスの「\」は「\\」に、URLの「/」「.」は「\/」「\.」に置き換えて下さい。
	
	// PeerCastのチャンネルを再生する専用プレイヤーのパスを指定。
	const playerPath = 'C:\\Program Files\\pcwmp\\pcwmp.exe';
	
	// 専用プレイヤーで再生するURL（＆ポート）を正規表現で指定。
	const playerUrl = /^http:\/\/localhost:7144\/pls\//;
	
	// 2chなどの掲示板を閲覧する2chブラウザのパスを指定。
	const browserPath = 'C:\\Program Files\\Jane Style\\Jane2ch.exe';
	
	// 2chブラウザで開くURLの一部を正規表現で指定。
	const browserUrl = [
		/^http:\/\/\w+?\.2ch\.net\/\w+?\//,
		/^http:\/\/\w+?\.60\.kg\/\w+?\//,
		/^http:\/\/jbbs\.livedoor\.jp\/\w+?\//,
		/^http:\/\/\w+?\.kakiko\.com\/\w+?\//
	];
	// ■■ 設定ここまで ■■
	
	if(event.button == 1) {
		var args = [href];
		if(href.match(playerUrl)) {
			try {
				args.push(ucjsConvertCharCodeFrom(event.target.id, "shift_jis"));
				ucjsExecute(playerPath, args);
			} catch(e) {}
		} else {
			for(var i=0; i<browserUrl.length; i++) {
				if(href.match(browserUrl[i])) {
					try {
						ucjsExecute(browserPath, args);
					} catch(e) {}
					break;
				}
			}
			if(i == browserUrl.length) ucjs_old_handleLinkClick(event, href, linkNode);
		}
	}
}

var ucjsExecute = function(filePath, args) {
	var localFile = this.ucjsExecuteGetLocalFile(filePath);
	if(! localFile) return false;
	var process = Components.classes['@mozilla.org/process/util;1'].getService(Components.interfaces.nsIProcess);
	try {
		process.init(localFile);
		process.run(false, args, args.length);
	} catch(e) {
		return false;
	}
	return true;
}

var ucjsExecuteGetLocalFile = function(filePath) {
	var localFile = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
	try {
		localFile.initWithPath(filePath);
		return localFile;
	} catch(e) {}
	return null;
}

// JSActions 2.3より
var ucjsConvertCharCodeFrom = function(str, code) {
	var UConvID = "@mozilla.org/intl/scriptableunicodeconverter";
	var UConvIF  = Components.interfaces.nsIScriptableUnicodeConverter;
	var UConv = Components.classes[UConvID].getService(UConvIF);
	var tmpStr = "";
	try {
		UConv.charset = code;
		tmpStr = UConv.ConvertFromUnicode(str);
	} catch(e) {
		tmpStr = null;
	}
	return tmpStr;
}

var ucjs_old_handleLinkClick = handleLinkClick;
handleLinkClick = ucjs_rewrite_handleLinkClick;
